//
// 2darray.cpp : Defines the entry point for the console application.
// A C++ program demonstrating the use of a two-dimensional array
// Copyright (c) Chris H. Pappas and William H. Murray, 2001
//

#include "stdafx.h"
#include <iostream>
using namespace std;

#define iROWS 4
#define iCOLUMNS 5

int main(int argc, char* argv[])
{
  int irow;
  int icolumn;
  int istatus[iROWS][iCOLUMNS];
  int iadd;
  int imultiple;

  for(irow=0; irow < iROWS; irow++)
    for(icolumn=0; icolumn < iCOLUMNS; icolumn++) {
      iadd = iCOLUMNS - icolumn;
      imultiple = irow;
      istatus[irow][icolumn] = (irow+1) *
        icolumn + iadd * imultiple;
    }

  for(irow=0; irow<iROWS; irow++) {
    cout << "CURRENT ROW: " << irow << endl;
    cout << "RELATIVE DISTANCE FROM BASE: " << endl;
    for(icolumn=0; icolumn<iCOLUMNS; icolumn++)
      cout << " " << istatus[irow][icolumn];
    cout << "\n\n";
  }

  return(0);
}